/* 
(C) OOMusou 2011 http://oomusou.cnblogs.com

Filename    : digital_filter_1
Synthesizer : Quartus II 10.1
Description : degital filter 1
Release     : Feb.03,2011 1.0
*/

module digital_filter_1 (
  clk_50M,
  rst_n,
  host_rst_n,
  host_rst_n_filter
);

input  clk_50M;
input  rst_n;
input  host_rst_n;
output host_rst_n_filter;

reg host_rst_n_d1;
reg host_rst_n_d2;
reg host_rst_n_d3;

always@(posedge clk_50M or negedge rst_n) begin
  if (~rst_n) begin
    host_rst_n_d1 <= 1'b1;
    host_rst_n_d2 <= 1'b1;
    host_rst_n_d3 <= 1'b1;
  end
  else begin
    host_rst_n_d1 <= host_rst_n;
    host_rst_n_d2 <= host_rst_n_d1;
    host_rst_n_d3 <= host_rst_n_d2;
  end 
end

assign host_rst_n_filter = host_rst_n_d1 | host_rst_n_d2 | host_rst_n_d3;

endmodule